(*:Date: Fri Jun  5 07:55:27 BST 1998
*)

(*:Title: COMMANDS.m *)

(*:Title: COMMANDS Fri Dec 26 18:49:36 EST 1997
*)

(*:Author: Alfred Gray *)

(* Copyright 1993-1998 by Alfred Gray *)

(*:Package Version: 1.0 *)

(*:Mathematica Version: 2.2, 3.0 *)

(*:Summary: 
This administrative package consists of lists of curves, surfaces and miniprograms.  It is useful for debugging only.*)

BeginPackage["KAPPA2`","CURVES`","CSPROGS`"]

CURVES2DLIST:=
{
 agnesi[a][t],
 airyspiral[a][t],
 alysoidprime[a,b,c][t],
 archimedesspiral[n,a][t],
 astroid[n,a,b][t],
 bellcurve[mean,variance][t],
 bicorn[a][t],
 bow[a][t],
 bowtie[a,b][t],
 bulletnose[a,b][t],
 cardioid[a][t],
 cardioidunitspeed[a][s],
 cartesianoval[a,b][u,v],
 cassini[a,b,pm1,pm2][t],
 catenary[a][t],
 catenaryunitspeed[a][s],
 cayleysextic[a][t],
 circle[a][t],
 circleinvolute[1,a][t],
 circleinvoluteunitspeed[1,a][s],
 circleunitspeed[a][s],
 cissoid[a][t],
 clothoid[a][s],
 clothoidprime[n,a][t],
 cnccoprofile[pm,a,b][s],
 cnchyprofile[pm,a,b][s],
 cochleoid[n,a][t],
 conchoid[a,b][t],
 coshspiral[n,a][t],
 cothspiral[a][t],
 cpcprofile[pm,a,b][s],
 crosscurve[a,b][t],
 cubicparabola[a,b,c,d][t],
 cycloid[a,b][t],
 cycloidunitspeed[a,a][s],
 deltoid[a][t],
 deltoidbis[a][t],
 deltoidinvolute[a][t],
 deltoidunitspeed[a][s],
 diamond[n,a,b][t],
 eight[t],
 elasticainflect[a,k][s],
 elasticanoninflect[a,k][s],
 ellipse[a,b][t],
 ellipseinc[a,b,c,psi][t],
 epicycloid[a,b][t],
 epicycloidunitspeed[a,b][s],
 epispiral[n,a][t],
 epitrochoid[a,b,h][t],
 fermatspiral[a][t],
 folium[t],
 folium[n,a,b,c][t],
 genparabola[n][t],
 hankelspiral[n,a][t],
 hippopede[a,b][t],
 hyperbola[a,b][t],
 hyperbolabis[a,b][t],
 hyperbolicspiral[a][t],
 hypocycloid[a,b][t],
 hypocycloidinvolute[a,b][t],
 hypocycloidunitspeed[a,b][s],
 hypotrochoid[a,b,h][t],
 kampyle[a][t],
 kappacurve[a][t],
 keplerorbit[a,e][t],
 lemniscate[a][t],
 lemniscateunitspeed[a][s],
 limacon[a,b][t],
 line[a1,b1,a2,b2][t],
 lissajous[n,d,a,b][t],
 lituus[a][t],
 logistic[k,a,b][t],
 logspiral[a,b][t],
 logspiralunitspeed[a,b][s],
 nephroid[a][t],
 nephroidunitspeed[a][s],
 ngon[5,a][t],
 nielsenspiral[a][t],
 parabola[a][t],
 parabola[a,b][t],
 parabolicspiral[n,a,b][t],
 piriform[a,b][t],
 pseudocatenaryprime[a,b][t],
 rectangle[n,a,b][t],
 reuleauxpolygon[5,a][t],
 rose[n,a][t],
 sc[t],
 scarab[a,b][t],
 scunitspeed[s],
 semicubic[a,b,c,d][z],
 serpentine[a,b][t],
 sinhspiral[n,a][t],
 sinoval[5,a][t],
 spring[a,b,v][t],
 strophoid[a][t],
 talbot[a,b,f][t],
 tanhspiral[a][t],
 teardrop[a,b,c,d,n][t],
 tractrix[a][t],
 tractrixminus[a][s],
 tractrixplus[a][s],
 tractrixunitspeed[a][s],
 triangle[t],
 trident[a,b,c,d][t],
 trisectrix[a][t],
 tschirnhausen[n,a][t],
 watt[a,b,c][t],
 zcprofile[pm,a,c][t]
}

CURVES2DPLOT:=
{
 agnesi[1][-1.1,1.1],
 airyspiral[1][-20,1],
 alysoid[1,1,3][-1.1,1.1],
 archimedesspiral[3,1][0,4Pi],
 astroid[3,1,1][0,2Pi],
 bellcurve[0,1][-3,3],
 bicorn[1][-Pi,Pi],
 bow[1][-Pi,Pi],
 bowtie[1,0.04][0,2Pi],
 bulletnose[3,1][-2Pi,2Pi],
 cardioid[1][0,2Pi],
 cassini[1.99,2,1,1][-Pi,Pi],
 catenary[-1][-2,2],
 cayleysextic[1][0,2Pi],
 circle[1][0,2Pi],
 circleinvolute[1,1][0,2Pi],
 cissoid[1][-2,2],
 clothoid[1,1][-5,5],
 cnccoprofile[1,1,0.3][-1.87,1.87],
 cnchyprofile[1,1,0.7][-1.15,1.15],
 cochleoid[1,1][-4Pi,4Pi],
 conchoid[4,-2][-Pi/2,Pi/2],
 coshspiral[1,1][-Pi,Pi],
 cothspiral[2][-Pi/2,Pi/2],
 cpcprofile[1,1,0.5][-Pi/2,Pi/2],
 crosscurve[1,2][-Pi,Pi],
 cubicparabola[1,0,-1,0][-2,2],
 cycloid[1,2][-4Pi,2Pi],
 deltoid[1][0,2Pi],
 deltoidbis[1][0,2Pi]
 deltoidinvolute[1][-2Pi,2Pi],
 diamond[0.5,1,1.5][0.1,6.38],
 eight[-Pi,Pi],
 elasticainflect[1,0.8][-8,8],
 elasticanoninflect[1,0.8][-8,8],
 ellipse[1,2][0,2Pi],
 ellipseinc[1,2,-1,Pi/4][0,3Pi],
 epicycloid[5,2][0,4Pi],
 epispiral[5,1][0,2Pi],
 epitrochoid[7,1,2][0,2Pi],
 fermatspiral[0.25,1][-4Pi,4Pi],
 folium[-0.999,60],
 genparabola[3][-1,1],
 hankelspiral[1,1][0.1,14],
 hippopede[1.5,1][0,2Pi],
 hyperbola[1,2][-2,2],
 hyperbolabis[1,2][-1,1],
 hyperbolicspiral[1][0.03Pi,6Pi],
 hypocycloid[8,1][0,2Pi],
 hypocycloidinvolute[5,1][0,4Pi],
 hypocycloidunitspeed[a,b][s],
 hypotrochoid[5,1,2][0,2Pi],
 kampyle[1][-Pi,Pi],
 kappacurve[1][0,2Pi,PlotRange->{{-2,2},Automatic}],
 keplerorbit[2,0.7][0,2Pi],
 lehr[1,5,3][0,2Pi],
 lemniscate[1][0,2Pi],
 lemniscatebis[1][-Pi/4,Pi/4],
 limacon[-1,1][0,2Pi],
 lissajous[3/4,0,9,8][0,8Pi],
 lituus[1][-0.2,12Pi],
 logistic[3,2,-2][-3,3],
 logspiral[1,0.04][0,12Pi],
 nephroid[1][0,2Pi],
 ngon[5,1][0,1],
 nielsenspiral[1][0.1,12Pi],
 parabola[1][-1.5,1.5],
 parabolicspiral[0.25,1,1][-6Pi,2Pi],
 piriform[1,1][0,2Pi],
 pseudocatenary[1,0.3][-1,1],
 rectangle[2,1,2][0.1,6.38],
 reuleauxpolygon[3,1][0,1],
 rose[3,1][0,Pi],
 sc[-2,2],
 scarab[1,1][0,2Pi],
 semicubic[4,0,-189.07,0][0.1,0.9],
 serpentine[2,2][-3,3],
 sinhspiral[2,1][0.01,Pi-0.01],
 sinoval[3,1][0,2Pi],
 spring[1,0.03,Pi/4][0,30Pi],
 strophoid[1,1][-5,5],
 talbot[1,1,0.9][-Pi,Pi],
 tanhspiral[1][-Pi/2,Pi/2],
 teardrop[a,b,c,d,n][t],
 tractrix[1][0.01,Pi-0.1],
 tractrixminus[1][0.01,1],
 tractrixplus[a][s],
 triangle[0,3],
 trident[1,0,0,1][-1,1],
 trisectrix[1][-0.49Pi,0.49Pi],
 tschirnhausen[1,1][-1.4Pi,1.4Pi],
 watt[1,2,1][-2Pi,2Pi],
 zcprofile[1,1,1][1,3]
}

ICURVS2DINFO:=
{
 agnesiimplicit,
 astroidimplicit,
 bulletnoseimplicit,
 cardioidimplicit,
 cartesianimplicit,
 cassiniimplicit,
 circleimplicit,
 cissoidimplicit,
 conchoidimplicit,
 crosscurveimplicit,
 cubicparabolaimplicit,
 deltoidimplicit,
 devilimplicit,
 duererimplicit,
 ellipseimplicit,
 foliumimplicit,
 hippopedeimplicit,
 hyperbolaimplicit,
 kappacurveimplicit,
 keplerimplicit,
 lemniscateimplicit,
 limaconimplicit,
 nephroidimplicit,
 newtonphillipsimplicit,
 parabolaimplicit,
 perseusimplicit,
 piriformimplicit,
 predatorpreyimplicit,
 scimplicit,
 semicubicimplicit,
 serpentineimplicit,
 strophoidimplicit,
 tridentimplicit,
 wattimplicit
}

ICURVS2DLIST:=
{
 agnesiimplicit[a][x,y],
 astroidimplicit[n,a,b][x,y],
 bulletnoseimplicit[a,b][x,y],
 cardioidimplicit[a][x,y],
 cartesianimplicit[a,c,m][x,y],
 cassiniimplicit[a,b][x,y],
 circleimplicit[a][x,y],
 cissoidimplicit[a][x,y],
 conchoidimplicit[a,b][x,y],
 crosscurveimplicit[a,b][x,y],
 cubicparabolaimplicit[a,b,c,d][x,y],
 deltoidimplicit[a][x,y],
 devilimplicit[a,b][x,y],
 duererimplicit[a,b][x,y],
 ellipseimplicit[a,b][x,y],
 foliumimplicit[x,y],
 foliumimplicit[n,a,b,c][x,y],
 hippopedeimplicit[a,b][x,y],
 hyperbolaimplicit[a,b][x,y],
 kappacurveimplicit[a][x,y],
 keplerimplicit[a,b][x,y],
 lemniscateimplicit[a][x,y],
 limaconimplicit[a,b][x,y],
 nephroidimplicit[a][x,y],
 newtonphillipsimplicit[m,n,a,b][x,y],
 parabolaimplicit[a][x,y],
 perseusimplicit[a,b,c][x,y],
 piriformimplicit[a,b][x,y],
 predatorpreyimplicit[a,b,p,q,c][x,y],
 scimplicit[x,y],
 semicubicimplicit[a,b,c,d][x,y],
 serpentineimplicit[a,b][x,y],
 strophoidimplicit[a][x,y],
 tridentimplicit[a,b,c,d][x,y],
 wattimplicit[a,b,c][x,y]
}

ICURVS2DPLOT:=
{
 agnesiimplicit[1][{-5,5}],
 bulletnoseimplicit[1,1][{-1,1}],
 cardioidimplicit[1][{-0.5,4.1}],
 cartesianimplicit[1,3,2][{-2,8}],
 cassiniimplicit[2.01,2][{-3,3}],
 circleimplicit[1][{-1,1}],
 cissoidimplicit[1][{0,1}],
 conchoidimplicit[4,1][{-4,5}],
 crosscurveimplicit[1,1][{-4,4}],
 cubicparabolaimplicit[1,-2,-1,0][{-2,3}],
 deltoidimplicit[1][{-1.5,3}],
 devilimplicit[1.5,1][{-2,2}],
 duererimplicit[1,1][{-10,10}],
 ellipseimplicit[2,1][{-2,2}],
 foliumimplicit[5,2,-1,1][{-1,1}],
 hippopedeimplicit[1.1,1][{-3,3}],
 hyperbolaimplicit[1,2][{-2,2}],
 kappacurveimplicit[2][{-2,2}],
 keplerimplicit[2,1][{-1,3}],
 lemniscateimplicit[1][{-1,1}],
 limaconimplicit[2,1][{-1,5}],
 nephroidimplicit[1][{-3,3}],
 parabolaimplicit[1][{-3,3}],
 perseusimplicit[5,3,1.9][{-11,11}],
 piriformimplicit[1,1][{0,2}],
 scimplicit[{-1,1}],
 semicubicimplicit[1,0,-1,0][{-2,2}],
 serpentineimplicit[3,3][{-2,2}],
 strophoidimplicit[1,1][{-2,2}],
 tridentimplicit[1,1,1,1][{-2.001,2}]
}

PCURVS2DLIST:=
{
 archimedesspiralpolar[n,a][theta],
 bowpolar[a][theta],
 cardioidpolar[a][theta],
 cassinipolar[a,b,pm1,pm2][theta],
 cochleoidpolar[n,a][theta],
 epispiralpolar[n,a][theta],
 fermatspiralpolar[a][theta],
 foliumpolar[t],
 foliumpolar[n,a,b,c][theta],
 hyperbolicspiralpolar[a][theta],
 kampylepolar[a][theta],
 keplerorbitpolar[a,e][theta],
 lemniscatepolar[a][theta],
 limaconpolar[a,b][theta],
 lituuspolar[a][theta],
 logspiralpolar[a,b][theta],
 pacman[n][theta],
 rosepolar[n,a][theta]
}

CURVES3DLIST:=
{
 ast3d[n,a,b][t],
 baseballseam[a,c][t],
 besselcurve[a,b,c][t],
 bicylinder[a,b,pm][t],
 biquadratic[a,k][t],
 clelia[a][m,n][t],
 conicalhelix[a,b,c,d][t],
 cubicalellipse[a,b,c,d,e,f,pm][t],
 eightknot[t],
 epitrochoid3d[a,b,h,omega][t],
 genhelix[a,b][f][t],
 helix[a,b][t],
 helix[a,b,c][t],
 helixunitspeed[a,b][s],
 horopter[a,b][t],
 line3d[a1,b1,c1,a2,b2,c2][t],
 lissajous3d[n,d,a,b,c][t],
 oneparametersubgroup[mat,vec][t],
 pseudospheregeodesic[a,c,u0,pm][t],
 pseudosphericalloxodrome[a,b][t],
 seiffertspiral[a,k][t],
 sphericalcardioid[a][t],
 sphericalellipse[a,b,c,pm][t],
 sphericalhelix[a,b][t],
 sphericalloxodrome[a,b,c][t],
 sphericalnephroid[a][t],
 sphericalspiral[a][m,n][t],
 tennisballseam[n,a,b,c][t],
 torusknot[a,b,c][p,q][t],
 twicubic[t],
 veryflat[1][t],
 veryflat[2][t],
 viviani[a][t],
 wigglyellipse[n,a,b,c][t]
}

CURVES3DPLOT:=
{
 ast3d[3,1,1][0,2Pi],
 baseballseam[1,0.4][0,4Pi],
 besselcurve[-1/2,1/2,3/2][1,30],
 bicylinder[1,1.01,1][0,2Pi][t],
 biquadratic[1,0.9][0,12],
 clelia[1][7/8,5][0,Pi],
 conicalhelix[1,1,2,20][-2Pi,2Pi],
 cubicalellipse[1,1,3,1,0,1/4,1][-2Pi,2Pi],
 eightknot[0,2Pi],
 epitrochoid3d[8,1,4,0.4Pi][0,2Pi],
 genhelix[1,1][3#^0.3&][0,9Pi],
 helix[1,3,0.5][0,4Pi],
 horopter[1,1][-2,2],
 lissajous3d[3/4,0,9,8,4][0,8Pi],
 oneparametersubgroup[{{0,1,0},{-1,0,0},{1,0,1}},{1,-1,-1/10}][-3Pi,5Pi/4],
 pseudospheregeodesic[1,0.25,Pi,1][0.5Pi,0.919569Pi],
 pseudosphericalloxodrome[1,4][-2.8,2.8],
 seiffertspiral[1.0,0.9][-3Pi,5Pi/4],
 sphericalcardioid[1/3][0,4Pi],
 sphericalellipse[1,0.8,0.1,1][-3,3],
 sphericalhelix[3/5,1/5][0,6Pi],
 sphericalloxodrome[1,1,0.2][-20,20],
 sphericalnephroid[1][0,2Pi],
 sphericalspiral[1][24,1][-Pi/2,Pi/2],
 tennisballseam[3,1,1,0.1][0,2Pi],
 torusknot[8,3,5][2,5][0,3Pi],
 twicubic[0,1],
 veryflat[1][-1,1],
 viviani[1][-2Pi,2Pi],
 wigglyellipse[3,1,1,0.1][0,2Pi]
}

CURVESNDLIST:=
{
 besseln[5,a][t],
 beziercurve[pts][t],
 cosn[5,a][t],
 sinn[5,a][t],
 twistedn[5,a][t]
}

SURFSLIST:=
{
 agnesirev[a][u,v],
 apple[u,v],
 astell[a,b,c][u,v],
 bohdom[a,b,c][u,v],
 bour[u,v],
 bourpolar[n][t][r,theta],
 bourpolar[m,n][t][r,theta],
 boy[a,b,c][u,v],
 catalan[a][u,v],
 catalandef[a][t][u,v],
 catenoid[c][u,v],
 catenoid[a,b,c][u,v],
 catenoidasym[a][p,q],
 catenoidiso[a][u,v],
 circleinvolutemin[1,a][t][u,v],
 circularcone[a,b][u,v],
 circularcylinder[a][u,v],
 clothoidmin[a][t][u,v],
 cnccosurfrev[a,b][u,v],
 cnchysurfrev[a,b][u,v],
 cncsurfrev[a,b][u,v],
 cnctcheb[a,b][u,v],
 cossurface[a][u,v],
 costa[u,v],
 cpcsurfrev[a,b][u,v],
 crosscap[a][u,v],
 deltoidinvolutemin[a][t][u,v],
 deltoidmin[a][t][u,v],
 dini[a,b][u,v],
 dinitcheb[a,b][u,v],
 dinitcheb[a,b,c][u,v],
 earth[u,v],
 eighteight[u,v],
 eightsurface[u,v],
 ellhypcyclide[a,c,k][u,v],
 ellipsemin[a,b][t][u,v],
 ellipsoid[a,b,c][u,v],
 ellipsoid[a,c][u,v],
 ellipticalhyperboloidminus[a,b,c][u,v],
 ellipticalhyperboloidplus[a,b,c][u,v],
 ellipticcoor[d,e,f][a,b,c][w][u,v],
 ellipticparaboloid[a,b][u,v],
 enneper[u,v],
 ennepercatenoidpolar[n][t][r,theta],
 enneperpolar[n][t][r,theta],
 exptwist[a,c][u,v],
 exptwistasym[a,c][p,q],
 flattorus[a,b][u,v],
 flattorus[a,b,c,d][u,v],
 funnel[a,b,c][u,v],
 funnelasym[c][p,q],
 gencube[n,a,b,c][u,v],
 genhypparab[a,b][u,v],
 genoctahedron[n,a,b,c][u,v],
 handkerchief[a][u,v],
 heart[a][u,v],
 helicoid[a,b,c][u,v],
 helicoid[a,c][u,v],
 helicoidprin[b][p,q],
 heltocat[t][u,v],
 henneberg[u,v],
 hyperbolicparaboloid[u,v],
 hyperbolicparaboloid[a][u,v],
 hyperboloid[a,b,c][u,v],
 hyperboloid[a,c][u,v],
 hypocycloidinvolutemin[a,b][t][u,v],
 hy2sheet[a,b,c][u,v],
 hy2sheet[a,c][u,v],
 invertedcircularcone[{p1,p2,p3},rho,a,b][u,v],
 invertedcircularcone[rho,a,b][u,v],
 invertedcircularcylinder[{p1,p2,p3},rho,a][u,v],
 invertedcircularcylinder[rho,a][u,v],
 invertedtorus[{p1,p2,p3},rho,a,b][u,v],
 invertedtorus[rho,a,b][u,v],
 kidney[a][u,v],
 kleinbottle[a][u,v],
 kleinbottlebis[e,f][u,v],
 kleinbottlewri[u,v],
 klein4[a,b][u,v],
 kuen[a][u,v],
 kuentcheb[a][u,v],
 kuentcheb[a,b][u,v],
 kuentcheb[a,b,c][u,v],
 lemniscatemin[a][t][u,v],
 menn[a][u,v],
 mercatorellipsoid[a,b,c][u,v],
 mercatorsphere[a][u,v],
 moebcirc[a][u,v],
 moebiusstrip[a][u,v],
 monkeysaddle[u,v],
 monkeysaddle[n][r,theta],
 monkeysaddlepolar[n][r,theta],
 parabolamin[a][t][u,v],
 paraboliccoor[d,e,f][a,b,c][w][u,v],
 paraboliccyclide[a,k][u,v],
 paraboloid[a][u,v],
 paraboloid[a,b][u,v],
 paraboloid[a,b,c][u,v],
 paraboloidpolar[n,a,b][r,theta],
 pear[a,b][u,v],
 pearbis[u,v],
 perturbedms[a][u,v],
 pillow[a][u,v],
 plane[a1,a2,b1,b2,c1,c2][u,v],
 planepolar[a][r,theta],
 planepolar[a,b][r,theta],
 planetocat[t][u,v],
 plucker[u,v],
 plucker[n][u,v],
 plucker[m,n,a][u,v],
 pluckerpolar[n][r,theta],
 pluckerpolar[m,n,a][r,theta],
 pseudocrosscap[u,v],
 pseudosphere[a][u,v],
 pseudosphere[a,b][u,v],
 pseudosphere[a,b,c][u,v],
 pseudospherebis[a][u,v],
 pseudospheretcheb[a][u,v],
 pseudospheretcheb[a,b][u,v],
 pseudospheretcheb[a,b,c][u,v],
 pseudospheretcheb[a,b,c,d][u,v],
 rconoid[u,v],
 richmond[u,v],
 richmondpolar[n][t][r,theta],
 roman[a][u,v],
 roman[n,a][u,v],
 rosemin[n,a][t][u,v],
 scherk[a][u,v],
 scherk[a,theta][u,v],
 scherk5[a,b,c][u,v],
 shoe[a,b][u,v],
 shoeasym[a,b][p,q],
 sievert[a][u,v],
 sinovaloid[5,a][u,v],
 sinsurface[a][u,v],
 snail[u,v],
 sphere[a][u,v],
 stereographicellipsoid[a,b,c][u,v],
 stereographicsphere[a][u,v],
 stereographicspherepolar[a][r,theta],
 swallowtail[u,v],
 tetrahedral[m,n][A,B,C][a,b,c][u,v],
 thomsen[a,b][u,v],
 torus[a,b][u,v],
 torus[a,b,c][u,v],
 torus[a,b,c,d][u,v],
 torus[a,b,c,d,e][u,v],
 twiflat[pm,a,c][sl][u,v],
 twisphere[a,b][u,v],
 veronese[a][u,v],
 wallis[a,b,c][u,v],
 whitneyumbrella[u,v],
 wrinkles[a][u,v]
}

ISURFSLIST:=
{
 cossurfaceimplicit[a][x,y,z],
 crosscapimplicit[a,b][x,y,z],
 ellipsoidimplicit[a,b,c][x,y,z],
 ellipticparaboloidimplicit[a,b,c][x,y,z],
 equihom1implicit[x,y,z]==0,
 equihom2implicit[x,y,z]==0,
 equihom3implicit[x,y,z]==0,
 equihom4implicit[x,y,z]==0,
 equihom5implicit[x,y,z]==0,
 equihom6implicit[x,y,z]==0,
 goursatimplicit[a,b,c][x,y,z],
 hyperbolicparaboloidimplicit[a,b,c][x,y,z],
 hyperboloidimplicit[a,b,c][x,y,z],
 hy2sheetimplicit[a,b,c][x,y,z],
 kazoolaimplicit[a,b,c,d][x,y,z],
 kummerimplicit[x,y,z],
 scherkimplicit[a][x,y,z],
 scherk5implicit[x,y,z],
 sinsurfaceimplicit[a][x,y,z],
 sphereimplicit[a][x,y,z],
 torusimplicit[a,b][x,y,z],
 twocuspsimplicit[x,y,z]
}


MINCURVSLIST:=
{
 astroidmincurve[a][z],
 bourmincurve[m][z],
 bourmincurve[m,n][z],
 cardioidmincurve[a][z],
 catalanmincurve[a][z],
 catenoidmincurve[a][z],
 cayleysexticmincurve[a][z],
 circleinvolutemincurve[2,a][z],
 cissoidmincurve[a][z],
 clothoidmincurve[a][z],
 cnchyprofilemincurve[pm,a,b][z],
 costamincurve[z],
 cpcprofilemincurve[pm,a,b][z],
 deltoidmincurve[a][z],
 ellipsemincurve[a,b][z],
 ennepercatenoidmincurve[n][z],
 ennepermincurve[n][z],
 epicycloidmincurve[a,b][z],
 hennebergmincurve[z],
 hyperbolamincurve[a,b][z],
 hypocycloidmincurve[a,b][z],
 lemniscatemincurve[a][z],
 logspiralmincurve[a,b][z],
 nephroidmincurve[a][z],
 nielsenspiralmincurve[a][z],
 parabolamincurve[a][z],
 richmondmincurve[n][z],
 rosemincurve[n,a][z],
 scmincurve[z],
 tractrixmincurve[a][z],
 trinoidmincurve[z]
}

PLTPROGSLIST:=
{
 centerlines[surface,{u,u0,u1},{v,v0,v1},opts],
 dip[ins],
 elrot[p,q][theta][aa_List],
 filledcurve[surface,{u,u0,u1},{v,v0,v1},opts],
 graphics2dtosurfrev[r,n][list],
 lathe[dots],
 linetolinesLine[pts],
 orth4d[surf,{u,umin,umax},{v,vmin,vmax},opts],
 plotpatch2d[surf,{u,umin,umax},{v,vmin,vmax},opts],
 paramcurveplot1[surface,{u,u0,u1},{v,v0,v1},opts],
 paramcurveplot2[surface,{u,u0,u1},{v,v0,v1},opts],
 selectcolgraphics3d[graphics3dobj,bound,opts],
 selectgraphics3d[graphics3dobj,bound,opts],
 stereo4d[{a,b,c,d},surf,{u,umin,umax},{v,vmin,vmax},opts],
 surfacecurveplot[surface,{u,u0,u1},{v,v0,v1},
   PlotLines->{ulines,vlines},PlotPoints->{upoints,vpoints
   },opts],
 wireframe[surface,{u,u0,u1},{v,v0,v1},opts]
}

CSPROGSLIST:=
{
 analytictominimal[Psi][t][u,v],
 analytictominimalpolar[Psi][t][r,theta],
 arclength[alpha][t],
 arclengthea[alpha][t],
 arclengthprimeea[alpha][t],
 arclengthprime[alpha][t],
 asymeq1[x][u,v],
 asymeq2[x][u,v],
 binormal[alpha][t],
 binormalsurf[alpha][u,v],
 brioschicurvature[x][u,v],
 brioschicurvature[ee,ff,gg][u,v],
 canalsurf[gamma][r][t,theta],
 christoffel[i,j,k][x][u,v],
 christoffel[i,j,k][ee,ff,gg][u,v],
 circle3point[{p1,q1},{p2,q2},{p3,q3}],
 combescure[alpha][f][t],
 cone[{p1,p2,p3},gamma][u,v],
 cross[u,v],
 ctor[z],
 curveonsurf[surf,alpha][t],
 cylinder[{q1,q2,q3},gamma][u,v],
 darbouxvector[gamma][t],
 der[v][ww][x,y],
 der[v][ww][x,y,z],
 divergence[ww][x,y],
 divergence[ww][x,y,z],
 ee[x][u,v],
 eee[x][u,v],
 eeee[x][u,v],
 evolute[alpha][t],
 evolute[n,alpha][t],
 evolute3d[gamma][t],
 ff[x][u,v],
 fff[x][u,v],
 ffff[x][u,v],
 filament[gamma][f,r][t],
 focalkmu[x][u,v],
 focalkpi[x][u,v],
 focalk1[x][u,v],
 focalk2[x][u,v],
 frenetframe[alpha][t],
 frenetframe[alpha,offset][t],
 frenetframe[alpha,offset,font,size][t],
 gaussiancurvature[x][u,v],
 gcurvature[x][u,v],
 genhel[alpha][sl][u,v],
 gensurfrev[alpha,gamma][u,v],
 geo[x][p,q,u,v],
 geo[ee,ff,gg][p,q,u,v],
 geodesiccurvature[surf,alpha][t],
 geodesictorsion[surf,alpha][t],
 geomincurve[alpha][z],
 gg[x][u,v],
 ggg[x][u,v],
 gggg[x][u,v],
 gmap[g][x,y],
 gmap[g][x,y,z],
 grad[g][x,y],
 grad[g][x,y,z],
 harmonictoanalytic[x][z],
 harmonictoanalytic[x][x0,y0][z],
 helical[alpha,a][t],
 helical[alpha][f][t],
 infarea[x][u,v],
 inscurv[n,a,alpha][t],
 intrinsic[fun,a,{c,d,theta0},optsnd,{smin,smax}],
 inversion[p,rho][x],
 inversion[rho][x],
 inversioncurve[p,rho][alpha][t],
 inversioncurve[rho][alpha][t],
 inversionsurf[p,rho][surf][u,v],
 involute[alpha,c][t],
 involute[alpha][t],
 involutends[a,b][alpha][t],
 J[{p1,p2}],
 jacobian2[x][u,v],
 kappa[alpha][t],
 kappan[alpha][t],
 kappa2[alpha][t],
 kappa2c[alpha][t],
 kappa2ea[alpha][t],
 kappa2implicit[g][x,y],
 kappa2polar[rho][t],
 kappa23d[alpha][t],
 kappa23d[mag,alpha][t],
 kmu[x][u,v],
 kpi[x][u,v],
 k1[x][u,v],
 k2[x][u,v],
 laplacian[g][x,y],
 laplacian[g][x,y,z],
 length[a,b][alpha],
 lengthea[a,b][alpha],
 lengthn[a,b][alpha],
 lengthean[a,b][alpha],
 lengthnds[a,b][alpha][t],
 lengtheands[a,b][alpha][t],
 mcurvature[x][u,v],
 meancurvature[x][u,v],
 meancurvaturevf[x][u,v],
 monge[h][u,v],
 mongepolar[g][r,theta],
 nateq[alpha][k2,s],
 nestedevolutes[n,alpha][t],
 normal[alpha][t],
 normalcurvature[surf,alpha][t],
 normalline[alpha][s,t],
 normalsurf[alpha][u,v],
 osculatingcircle[alpha][t],
 paramtoimp[alpha,{x,y}],
 parcurve[alpha][s][t],
 parsurf[x][r][u,v],
 pedal[{a,b},alpha][t],
 pedal[alpha][t],
 pedsurf[{a,b,c},x][u,v],
 pedsurf[x][u,v],
 perpsurf[phi,alpha][u,v],
 planeframe[alpha][t],
 planeframe[alpha,offset][t],
 planeframe[alpha,offset,font,size][t],
 plotintrinsic[fun,a,{c,d,theta0},optsnd,{smin,smax},optspp],
 plotintrinsic3d[{kk,tt},{a,{p1,p2,p3},{q1,q2,q3},
     {r1,r2,r3}},{smin,smax},opts],
 plottl[alpha,t0,{tmin,tmax},opts],
 plottp[x,{u0,v0},{umin,umax},{vmin,vmax},opts],
 polarize[func][r,theta],
 polarsurf[gamma][u,v],
 rf[p,alpha][t],
 rollcurve[alpha,b,h,c][t],
 rt[theta,alpha][t],
 rtoc[{x,y}],
 ruled[alpha,gamma][u,v],
 seashell[gamma][r][t,theta],
 solvegeoeqs[x,a:0,{u0:0,v0:0},tfin,div,optsnd],
 stereoinj[a][p],
 stereoproj[a][q],
 stretch[a,b,c,surf][u,v],
 surfacejacobian[x][u,v],
 surfacejacobianmatrix[x][u,v],
 surfacenormal[x][u,v],
 surfast[n,alpha][u,v],
 surfrev[alpha][u,v],
 tandev[alpha][u,v],
 tangent[alpha][t],
 tangentkmu[x][u,v],
 tangentkpi[x][u,v],
 tangentline[alpha][s,t],
 tangentplane[x][u0,v0][u,v],
 tau[alpha][t],
 tl[p,alpha][t],
 totalacsalrcurvature[a,b,alpha],
 transsurf[alpha,gamma][u,v],
 tubecurve[gamma][r][t,theta],
 tubeplanecurve[gamma][r][t,theta],
 turningangle[alpha][t],
 turningnumber[alpha,{a,b},opts],
 twist[a,b,gamma][u,v],
 umeqs[k][x][u,v],
 unitnormal[x][u,v],
 wei[f,g][z],
 weicurvature[f,g][z],
 weimetric[f,g][z],
 weingarten[x][u,v],
 weinormal[g][z],
 weipolar[f,g][t][r,theta],
 weiprime[f,g][z],
 writhe[alpha][t]
}

kappa2LIST:=
{
 kappa2[agnesi[a]][t],
 kappa2[airyspiral[a]][t],
 kappa2[alysoidprime[a,b,c]][t],
 kappa2[archimedesspiral[n,a]][t],
 kappa2[astroid[n,a,b]][t],
 kappa2[bellcurve[mean,variance]][t],
 kappa2[bicorn[a]][t],
 kappa2[bow[a]][t],
 kappa2[bowtie[a,b]][t],
 kappa2[bulletnose[a,b]][t],
 kappa2[cardioid[a]][t],
 kappa2[cardioidunitspeed[a]][s],
 kappa2[cartesianoval[a,b]][u,v],
 kappa2[cassini[a,b,pm1,pm2]][t],
 kappa2[catenary[a]][t],
 kappa2[cayleysextic[a]][t],
 kappa2[circle[a]][t],
 kappa2[circleinvolute[1,a]][t],
 kappa2[circleinvoluteunitspeed[1,a]][s],
 kappa2[circleunitspeed[a]][s],
 kappa2[cissoid[a]][t],
 kappa2[clothoid[1,a]][t],
 kappa2[clothoidprime[n,a]][t],
 kappa2[cnccoprofile[pm,a,b]][t],
 kappa2[cnchyprofile[pm,a,b]][t],
 kappa2[cochleoid[n,a]][t],
 kappa2[conchoid[a,b]][t],
 kappa2[coshspiral[n,a]][t],
 kappa2[cothspiral[a]][t],
 kappa2[cpcprofile[pm,a,b]][t],
 kappa2[crosscurve[a,b]][t],
 kappa2[cubicparabola[a,b,c,d]][t],
 kappa2[cycloid[a,b]][t],
 kappa2[cycloidunitspeed[a,a]][s],
 kappa2[deltoid[a]][t],
 kappa2[deltoidinvolute[a]][t],
 kappa2[deltoidunitspeed[a]][s],
 kappa2[diamond[n,a,b]][t],
 kappa2[eight][t],
 kappa2[elasticainflect[a,k]][t],
 kappa2[elasticanoninflect[a,k]][t],
 kappa2[ellipse[a,b]][t],
 kappa2[ellipsebis[a,b]][t],
 kappa2[ellipseinc[a,b,c,psi]][t],
 kappa2[epicycloid[a,b]][t],
 kappa2[epicycloidunitspeed[a,b]][s],
 kappa2[epispiral[n,a]][t],
 kappa2[epitrochoid[a,b,h]][t],
 kappa2[fermatspiral[a]][t],
 kappa2[folium][t],
 kappa2[folium[n,a,b,c]][t],
 kappa2[hankelspiral[n,a]][t],
 kappa2[hyperbola[a,b]][t],
 kappa2[hyperbolabis[a,b]][t],
 kappa2[hyperbolicspiral[a]][t],
 kappa2[hypocycloid[a,b]][t],
 kappa2[hypocycloidinvolute[a,b]][t],
 kappa2[hypotrochoid[a,b,h]][t],
 kappa2[kampyle[a]][t],
 kappa2[kappacurve[a]][t],
 kappa2[keplerorbit[a,e]][t],
 kappa2[lemniscate[a]][t],
 kappa2[lemniscateunitspeed[a]][s],
 kappa2[limacon[a,b]][t],
 kappa2[line[a1,b1,a2,b2]][t],
 kappa2[lissajous[n,d,a,b]][t],
 kappa2[lituus[a]][t],
 kappa2[logspiral[a,b]][t],
 kappa2[logistic[k,a,b]][t],
 kappa2[nephroid[a]][t],
 kappa2[nielsenspiral[a]][t],
 kappa2[parabola[a]][t],
 kappa2[parabolicspiral[n,a,b]][t],
 kappa2[piriform[a,b]][t],
 kappa2[rose[n,a]][t],
 kappa2[sc][t],
 kappa2[scunitspeed][s],
 kappa2[semicubic[a,b,c,d]][z],
 kappa2[serpentine[a,b]][t],
 kappa2[sinhspiral[n,a]][t],
 kappa2[sinoval[5,a]][t],
 kappa2[spring[a,b,v]][t],
 kappa2[strophoid[a]][t],
 kappa2[talbot[a,b,f]][t],
 kappa2[tanhspiral[a]][t],
 kappa2[teardrop[a,b,c,d,n]][t],
 kappa2[tractrix[a]][t],
 kappa2[tractrixminus[a]][s],
 kappa2[tractrixplus[a]][s],
 kappa2[tractrixunitspeed[a]][t],
 kappa2[triangle][t],
 kappa2[trisectrix[a]][t],
 kappa2[tschirnhausen[n,a]][t],
 kappa2[zcprofile[pm,a,c]][t]
}

kappa2eaLIST:=
{
 kappa2ea[agnesi[a]][t],
 kappa2ea[airyspiral[a]][t],
 kappa2ea[alysoidprime[a,b,c]][t],
 kappa2ea[archimedesspiral[n,a]][t],
 kappa2ea[astroid[n,a,b]][t],
 kappa2ea[bellcurve[mean,variance]][t],
 kappa2ea[bicorn[a]][t],
 kappa2ea[bow[a]][t],
 kappa2ea[bowtie[a,b]][t],
 kappa2ea[bulletnose[a,b]][t],
 kappa2ea[cardioid[a]][t],
 kappa2ea[cardioidunitspeed[a]][s],
 kappa2ea[cartesianoval[a,b]][u,v],
 kappa2ea[cassini[a,b,pm1,pm2]][t],
 kappa2ea[catenary[a]][t],
 kappa2ea[cayleysextic[a]][t],
 kappa2ea[circle[a]][t],
 kappa2ea[circleinvolute[1,a]][t],
 kappa2ea[circleinvoluteunitspeed[1,a]][s],
 kappa2ea[circleunitspeed[a]][s],
 kappa2ea[cissoid[a]][t],
 kappa2ea[clothoid[1,a]][t],
 kappa2ea[clothoidprime[n,a]][t],
 kappa2ea[cnccoprofile[pm,a,b]][t],
 kappa2ea[cnchyprofile[pm,a,b]][t],
 kappa2ea[cochleoid[n,a]][t],
 kappa2ea[conchoid[a,b]][t],
 kappa2ea[coshspiral[n,a]][t],
 kappa2ea[cothspiral[a]][t],
 kappa2ea[cpcprofile[pm,a,b]][t],
 kappa2ea[crosscurve[a,b]][t],
 kappa2ea[cubicparabola[a,b,c,d]][t],
 kappa2ea[cycloid[a,b]][t],
 kappa2ea[cycloidunitspeed[a,a]][s],
 kappa2ea[deltoid[a]][t],
 kappa2ea[deltoidinvolute[a]][t],
 kappa2ea[deltoidunitspeed[a]][s],
 kappa2ea[diamond[n,a,b]][t],
 kappa2ea[eight][t],
 kappa2ea[elasticainflect[a,k]][t],
 kappa2ea[elasticanoninflect[a,k]][t],
 kappa2ea[ellipse[a,b]][t],
 kappa2ea[ellipsebis[a,b]][t],
 kappa2ea[ellipseinc[a,b,c,psi]][t],
 kappa2ea[epicycloid[a,b]][t],
 kappa2ea[epicycloidunitspeed[a,b]][s],
 kappa2ea[epispiral[n,a]][t],
 kappa2ea[epitrochoid[a,b,h]][t],
 kappa2ea[fermatspiral[a]][t],
 kappa2ea[folium][t],
 kappa2ea[folium[n,a,b,c]][t],
 kappa2ea[hankelspiral[n,a]][t],
 kappa2ea[hyperbola[a,b]][t],
 kappa2ea[hyperbolabis[a,b]][t],
 kappa2ea[hyperbolicspiral[a]][t],
 kappa2ea[hypocycloid[a,b]][t],
 kappa2ea[hypocycloidinvolute[a,b]][t],
 kappa2ea[hypotrochoid[a,b,h]][t],
 kappa2ea[kampyle[a]][t],
 kappa2ea[kappacurve[a]][t],
 kappa2ea[keplerorbit[a,e]][t],
 kappa2ea[lemniscate[a]][t],
 kappa2ea[lemniscateunitspeed[a]][s],
 kappa2ea[limacon[a,b]][t],
 kappa2ea[line[a1,b1,a2,b2]][t],
 kappa2ea[lissajous[n,d,a,b]][t],
 kappa2ea[lituus[a]][t],
 kappa2ea[logspiral[a,b]][t],
 kappa2ea[logistic[k,a,b]][t],
 kappa2ea[nephroid[a]][t],
 kappa2ea[nielsenspiral[a]][t],
 kappa2ea[parabola[a]][t],
 kappa2ea[parabolicspiral[n,a,b]][t],
 kappa2ea[piriform[a,b]][t],
 kappa2ea[rose[n,a]][t],
 kappa2ea[sc][t],
 kappa2ea[scunitspeed][s],
 kappa2ea[semicubic[a,b,c,d]][z],
 kappa2ea[serpentine[a,b]][t],
 kappa2ea[sinhspiral[n,a]][t],
 kappa2ea[sinoval[5,a]][t],
 kappa2ea[spring[a,b,v]][t],
 kappa2ea[strophoid[a]][t],
 kappa2ea[talbot[a,b,f]][t],
 kappa2ea[tanhspiral[a]][t],
 kappa2ea[teardrop[a,b,c,d,n]][t],
 kappa2ea[tractrix[a]][t],
 kappa2ea[tractrixminus[a]][s],
 kappa2ea[tractrixplus[a]][s],
 kappa2ea[tractrixunitspeed[a]][t],
 kappa2ea[triangle][t],
 kappa2ea[trisectrix[a]][t],
 kappa2ea[tschirnhausen[n,a]][t],
 kappa2ea[zcprofile[pm,a,c]][t]
}

EVOLUTE2DLIST:=
{
 evolute[agnesi[a]][t],
 evolute[airyspiral[a]][t],
 evolute[alysoidprime[a,b,c]][t],
 evolute[archimedesspiral[n,a]][t],
 evolute[astroid[n,a,b]][t],
 evolute[bellcurve[mean,variance]][t],
 evolute[bicorn[a]][t],
 evolute[bow[a]][t],
 evolute[bowtie[a,b]][t],
 evolute[bulletnose[a,b]][t],
 evolute[cardioid[a]][t],
 evolute[cardioidunitspeed[a]][s],
 evolute[cartesianoval[a,b]][u,v],
 evolute[cassini[a,b,pm1,pm2]][t],
 evolute[catenary[a]][t],
 evolute[cayleysextic[a]][t],
 evolute[circle[a]][t],
 evolute[circleinvolute[1,a]][t],
 evolute[circleinvoluteunitspeed[1,a]][s],
 evolute[circleunitspeed[a]][s],
 evolute[cissoid[a]][t],
 evolute[clothoid[1,a]][t],
 evolute[clothoidprime[n,a]][t],
 evolute[cnccoprofile[pm,a,b]][t],
 evolute[cnchyprofile[pm,a,b]][t],
 evolute[cochleoid[n,a]][t],
 evolute[conchoid[a,b]][t],
 evolute[coshspiral[n,a]][t],
 evolute[cothspiral[a]][t],
 evolute[cpcprofile[pm,a,b]][t],
 evolute[crosscurve[a,b]][t],
 evolute[cubicparabola[a,b,c,d]][t],
 evolute[cycloid[a,b]][t],
 evolute[cycloidunitspeed[a,a]][s],
 evolute[deltoid[a]][t],
 evolute[deltoidinvolute[a]][t],
 evolute[deltoidunitspeed[a]][s],
 evolute[diamond[n,a,b]][t],
 evolute[eight][t],
 evolute[ellipse[a,b]][t],
 evolute[ellipseinc[a,b,c,psi]][t],
 evolute[epicycloid[a,b]][t],
 evolute[epicycloidunitspeed[a,b]][s],
 evolute[epispiral[n,a]][t],
 evolute[epitrochoid[a,b,h]][t],
 evolute[fermatspiral[a]][t],
 evolute[folium][t],
 evolute[folium[n,a,b,c]][t],
 evolute[hyperbola[a,b]][t],
 evolute[hyperbolabis[a,b]][t],
 evolute[hyperbolicspiral[a]][t],
 evolute[hypocycloid[a,b]][t],
 evolute[hypocycloidinvolute[a,b]][t],
 evolute[hypotrochoid[a,b,h]][t],
 evolute[kampyle[a]][t],
 evolute[keplerorbit[a,e]][t],
 evolute[lemniscate[a]][t],
 evolute[lemniscateunitspeed[a]][s],
 evolute[limacon[a,b]][t],
 evolute[line[a1,b1,a2,b2]][t],
 evolute[lissajous[n,d,a,b]][t],
 evolute[lituus[a]][t],
 evolute[logspiral[a,b]][t],
 evolute[logistic[k,a,b]][t],
 evolute[nephroid[a]][t],
 evolute[ngon[n,a]][t],
 evolute[nielsenspiral[a]][t],
 evolute[parabola[a]][t],
 evolute[parabolicspiral[n,a,b]][t],
 evolute[piriform[a,b]][t],
 evolute[rose[n,a]][t],
 evolute[sc][t],
 evolute[scunitspeed][s],
 evolute[semicubic[a,b,c,d]][z],
 evolute[serpentine[a,b]][t],
 evolute[sinhspiral[n,a]][t],
 evolute[sinoval[5,a]][t],
 evolute[spring[a,b,v]][t],
 evolute[strophoid[a]][t],
 evolute[talbot[a,b,f]][t],
 evolute[tanhspiral[a]][t],
 evolute[teardrop[a,b,c,d,n]][t],
 evolute[tractrix[a]][t],
 evolute[tractrixminus[a]][s],
 evolute[tractrixplus[a]][s],
 evolute[tractrixunitspeed[a]][t],
 evolute[triangle][t],
 evolute[trisectrix[a]][t],
 evolute[tschirnhausen[n,a]][t],
 evolute[zcprofile[pm,a,c]][t]
}

INVCURVES2DLIST:=
{
 inversioncurve[{p1,p2},rho][agnesi[a]][t],
 inversioncurve[{p1,p2},rho][archimedesspiral[n,a]][t],
 inversioncurve[{p1,p2},rho][astroid[n,a,b]][t],
 inversioncurve[{p1,p2},rho][cardioid[a]][t],
 inversioncurve[{p1,p2},rho][catenary[a]][t],
 inversioncurve[{p1,p2},rho][cayleysextic[a]][t],
 inversioncurve[{p1,p2},rho][circle[a]][t],
 inversioncurve[{p1,p2},rho][circleinvolute[1,a]][t],
 inversioncurve[{p1,p2},rho][cissoid[a]][t],
 inversioncurve[{p1,p2},rho][clothoid[1,a]][t],
 inversioncurve[{p1,p2},rho][clothoidprime[n,a]][t],
 inversioncurve[{p1,p2},rho][cnccoprofile[pm,a,b]][t],
 inversioncurve[{p1,p2},rho][cnchyprofile[pm,a,b]][t],
 inversioncurve[{p1,p2},rho][cochleoid[n,a]][t],
 inversioncurve[{p1,p2},rho][conchoid[a,b]][t],
 inversioncurve[{p1,p2},rho][cothspiral[a]][t],
 inversioncurve[{p1,p2},rho][cpcprofile[pm,a,b]][t],
 inversioncurve[{p1,p2},rho][cubicparabola[a,b,c,d]][t],
 inversioncurve[{p1,p2},rho][cycloid[a,b]][t],
 inversioncurve[{p1,p2},rho][deltoid[a]][t],
 inversioncurve[{p1,p2},rho][diamond[n,a,b]][t],
 inversioncurve[{p1,p2},rho][eight][t],
 inversioncurve[{p1,p2},rho][ellipse[a,b]][t],
 inversioncurve[{p1,p2},rho][epicycloid[a,b]][t],
 inversioncurve[{p1,p2},rho][epitrochoid[a,b,h]][t],
 inversioncurve[{p1,p2},rho][fermatspiral[a]][t],
 inversioncurve[{p1,p2},rho][folium][t],
 inversioncurve[{p1,p2},rho][hyperbola[a,b]][t],
 inversioncurve[{p1,p2},rho][hyperbolicspiral[a]][t],
 inversioncurve[{p1,p2},rho][hypocycloid[a,b]][t],
 inversioncurve[{p1,p2},rho][hypotrochoid[a,b,h]][t],
 inversioncurve[{p1,p2},rho][lemniscate[a]][t],
 inversioncurve[{p1,p2},rho][limacon[a,b]][t],
 inversioncurve[{p1,p2},rho][line[a1,b1,a2,b2]][t],
 inversioncurve[{p1,p2},rho][lissajous[n,d,a,b]][t],
 inversioncurve[{p1,p2},rho][lituus[a]][t],
 inversioncurve[{p1,p2},rho][logspiral[a,b]][t],
 inversioncurve[{p1,p2},rho][nephroid[a]][t],
 inversioncurve[{p1,p2},rho][nielsenspiral[a]][t],
 inversioncurve[{p1,p2},rho][parabola[a]][t],
 inversioncurve[{p1,p2},rho][piriform[a,b]][t],
 inversioncurve[{p1,p2},rho][rose[n,a]][t],
 inversioncurve[{p1,p2},rho][sc][t],
 inversioncurve[{p1,p2},rho][strophoid[a]][t],
 inversioncurve[{p1,p2},rho][talbot[a,b,f]][t],
 inversioncurve[{p1,p2},rho][tanhspiral[a]][t],
 inversioncurve[{p1,p2},rho][tractrix[a]][t],
 inversioncurve[{p1,p2},rho][triangle][t],
 inversioncurve[{p1,p2},rho][trisectrix[a]][t],
 inversioncurve[{p1,p2},rho][zcprofile[pm,a,c]][t]
}

INVSURFLIST:=
{inversionsurf[{p1,p2,p3},rho][astell[a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][bohdom[a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][bourpolar[n][t]][u,v],
   inversionsurf[{p1,p2,p3},rho][bourpolar[m,n][t]][u,v],
   inversionsurf[{p1,p2,p3},rho][boy[a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][catalan[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][catalandef[a][t]][u,v],
   inversionsurf[{p1,p2,p3},rho][catenoid[c]][u,v],
   inversionsurf[{p1,p2,p3},rho][circularcone[a,b]][u,v],
   inversionsurf[{p1,p2,p3},rho][circularcylinder[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][clothoidmin[a][t]][u,v],
   inversionsurf[{p1,p2,p3},rho][cnccosurfrev[a,b]][u,v],
   inversionsurf[{p1,p2,p3},rho][cnchysurfrev[a,b]][u,v],
   inversionsurf[{p1,p2,p3},rho][cpcsurfrev[a,b]][u,v],
   inversionsurf[{p1,p2,p3},rho][crosscap[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][dini[a,b]][u,v],
   inversionsurf[{p1,p2,p3},rho][dinitcheb[a,b]][u,v],
   inversionsurf[{p1,p2,p3},rho][ducyc[{q1,q2,q3},rho,a,b]][u,v],
   inversionsurf[{p1,p2,p3},rho][earth][u,v],
   inversionsurf[{p1,p2,p3},rho][eighteight][u,v],
   inversionsurf[{p1,p2,p3},rho][eightsurface][u,v],
   inversionsurf[{p1,p2,p3},rho][ellipsemin[a,b][t]][u,v],
   inversionsurf[{p1,p2,p3},rho][ellipsoid[a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][ellipsoid[a,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][ellipticalhyperboloidminus[a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][ellipticalhyperboloidplus[a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][ellipticcoor[d,e,f][a,b,c][w]][u,v],
   inversionsurf[{p1,p2,p3},rho][ellipticparaboloid[a,b]][u,v],
   inversionsurf[{p1,p2,p3},rho][enneper][u,v],
   inversionsurf[{p1,p2,p3},rho][enneperpolar[n][t]][u,v],
   inversionsurf[{p1,p2,p3},rho][ennepercatenoidpolar[n][t]][u,v],
   inversionsurf[{p1,p2,p3},rho][funnel[a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][genhypparab[a,b]][u,v],
   inversionsurf[{p1,p2,p3},rho][handkerchief[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][helicoid[a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][helicoid[a,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][helicoidprin[a,b]][u,v],
   inversionsurf[{p1,p2,p3},rho][heltocat[t]][u,v],
   inversionsurf[{p1,p2,p3},rho][henneberg][u,v],
   inversionsurf[{p1,p2,p3},rho][hyperbolicparaboloid][u,v],
   inversionsurf[{p1,p2,p3},rho][hyperboloid[a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][hyperboloid[a,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][hy2sheet[a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][hy2sheet[a,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][kidney[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][kleinbottle[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][kuen][u,v],
   inversionsurf[{p1,p2,p3},rho][kuentcheb[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][lemniscatemin[a][t]][u,v],
   inversionsurf[{p1,p2,p3},rho][menn[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][mercatorellipsoid[a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][moebcirc[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][moebiusstrip[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][monkey[n]][u,v],
   inversionsurf[{p1,p2,p3},rho][monkeysaddle][u,v],
   inversionsurf[{p1,p2,p3},rho][monkeysaddlepolar[n]][r,theta],
   inversionsurf[{p1,p2,p3},rho][paraboliccoor[d,e,f][a,b,c][w]][u,v],
   inversionsurf[{p1,p2,p3},rho][paraboloid[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][paraboloid[a,b]][u,v],
   inversionsurf[{p1,p2,p3},rho][paraboloid[a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][perturbedms[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][plane[a1,a2,b1,b2,c1,c2]][u,v],
   inversionsurf[{p1,p2,p3},rho][plucker][u,v],
   inversionsurf[{p1,p2,p3},rho][pluckerpolar[n]][u,v],
   inversionsurf[{p1,p2,p3},rho][pluckerpolar[m,n]][u,v],
   inversionsurf[{p1,p2,p3},rho][pseudocrosscap][u,v],
   inversionsurf[{p1,p2,p3},rho][pseudosphere[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][pseudospheretcheb[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][rconoid][u,v],
   inversionsurf[{p1,p2,p3},rho][richmond][u,v],
   inversionsurf[{p1,p2,p3},rho][richmondpolar[n][t]][u,v],
   inversionsurf[{p1,p2,p3},rho][roman[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][rosemin[n,a][t]][u,v],
   inversionsurf[{p1,p2,p3},rho][scherk[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][scherk[a,theta]][u,v],
   inversionsurf[{p1,p2,p3},rho][scherk5[a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][shoe][u,v],
   inversionsurf[{p1,p2,p3},rho][sievert[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][sinsurface[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][snail][u,v],
   inversionsurf[{p1,p2,p3},rho][sphere[a]][u,v],
   inversionsurf[{p1,p2,p3},rho][stereographicellipsoid[a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][swallowtail][u,v],
   inversionsurf[{p1,p2,p3},rho][tetrahedral[m,n][A,B,C][a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][thomsen[a,b]][u,v],
   inversionsurf[{p1,p2,p3},rho][torus[a,b]][u,v],
   inversionsurf[{p1,p2,p3},rho][torus[a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][twiflat[pm,a,c][sl]][u,v],
   inversionsurf[{p1,p2,p3},rho][twisphere[a,b]][u,v],
   inversionsurf[{p1,p2,p3},rho][wallis[a,b,c]][u,v],
   inversionsurf[{p1,p2,p3},rho][whitneyumbrella][u,v],
   inversionsurf[{p1,p2,p3},rho][wrinkles[a]][u,v]
}


PEDALCURVES2DLIST:=
{
 pedal[{p1,p2},agnesi[a]][t],
 pedal[{p1,p2},airyspiral[n,a]][t],
 pedal[{p1,p2},alysoid[a,b,c]][s],
 pedal[{p1,p2},alysoidprime[a,b,c]][t],
 pedal[{p1,p2},archimedesspiral[n,a]][t],
 pedal[{p1,p2},astroid[n,a,b]][t],
 pedal[{p1,p2},bellcurve[mean,variance]][t],
 pedal[{p1,p2},bicorn[a]][t],
 pedal[{p1,p2},bow[a]][t],
 pedal[{p1,p2},bowtie[a,b]][t],
 pedal[{p1,p2},bulletnose[a,b]][t],
 pedal[{p1,p2},cardioid[a]][t],
 pedal[{p1,p2},cardioidunitspeed[a]][s],
 pedal[{p1,p2},cartesianoval[a,b]][u,v].
 pedal[{p1,p2},cassini[a,b,pm1,pm2]][t],
 pedal[{p1,p2},catenary[a]][t],
 pedal[{p1,p2},cayleysextic[a]][t],
 pedal[{p1,p2},circle[a]][t],
 pedal[{p1,p2},circleinvolute[1,a]][t],
 pedal[{p1,p2},circleinvoluteunitspeed[1,a]][s],
 pedal[{p1,p2},circleunitspeed[a]][s],
 pedal[{p1,p2},cissoid[a]][t],
 pedal[{p1,p2},clothoid[1,a]][t],
 pedal[{p1,p2},clothoidprime[n,a]][t],
 pedal[{p1,p2},cnccoprofile[pm,a,b]][t],
 pedal[{p1,p2},cnchyprofile[pm,a,b]][t],
 pedal[{p1,p2},cochleoid[n,a]][t],
 pedal[{p1,p2},conchoid[a,b]][t],
 pedal[{p1,p2},coshspiral[n,a]][t],
 pedal[{p1,p2},cothspiral[a]][t],
 pedal[{p1,p2},cpcprofile[pm,a,b]][t],
 pedal[{p1,p2},cubicparabola[a,b,c,d]][t],
 pedal[{p1,p2},crosscurve[a,b]][t],
 pedal[{p1,p2},cycloid[a,b]][t],
 pedal[{p1,p2},cycloidunitspeed[a,a]][s],
 pedal[{p1,p2},deltoid[a]][t],
 pedal[{p1,p2},deltoidinvolute[a][t],
 pedal[{p1,p2},deltoidunitspeed[a]][s],
 pedal[{p1,p2},diamond[n,a,b]][t],
 pedal[{p1,p2},eight][t],
 pedal[{p1,p2},ellipse[a,b]][t],
 pedal[{p1,p2},ellipseinc[a,b,c,psi]][t],
 pedal[{p1,p2},epicycloid[a,b]][t],
 pedal[{p1,p2},epicycloidunitspeed[a,b]][s],
 pedal[{p1,p2},epispiral[n,a]][t],
 pedal[{p1,p2},epitrochoid[a,b,h]][t],
 pedal[{p1,p2},fermatspiral[a]][t],
 pedal[{p1,p2},folium]][t],
 pedal[{p1,p2},folium[n,a,b,c]][t],
 pedal[{p1,p2},hyperbola[a,b]][t],
 pedal[{p1,p2},hyperbolabis[a,b]][t],
 pedal[{p1,p2},hyperbolicspiral[a]][t],
 pedal[{p1,p2},hypocycloid[a,b]][t],
 pedal[hypocycloidinvolute[a,b]][t],
 pedal[{p1,p2},hypotrochoid[a,b,h]][t],
 pedal[{p1,p2},kampyle[a]][t],
 pedal[{p1,p2},keplerorbit[a,e]][t],
 pedal[{p1,p2},lemniscate[a]][t],
 pedal[{p1,p2},lemniscateunitspeed[a]][s],
 pedal[{p1,p2},limacon[a,b]][t],
 pedal[{p1,p2},line[a1,b1,a2,b2]][t],
 pedal[{p1,p2},lissajous[n,d,a,b]][t],
 pedal[{p1,p2},lituus[a]][t],
 pedal[{p1,p2},logspiral[a,b]][t],
 pedal[{p1,p2},logistic[k,a,b]][t],
 pedal[{p1,p2},nephroid[a]][t],
 pedal[{p1,p2},ngon[n,a]][t],
 pedal[{p1,p2},nielsenspiral[a]][t],
 pedal[{p1,p2},parabola[a]][t],
 pedal[{p1,p2},parabolicspiral[n,a,b]][t],
 pedal[{p1,p2},piriform[a,b]][t],
 pedal[{p1,p2},rose[n,a]][t],
 pedal[{p1,p2},sc][t],
 pedal[{p1,p2},scunitspeed][s],
 pedal[{p1,p2},semicubic[a,b,c,d]][z],
 pedal[{p1,p2},serpentine[a,b]][t],
 pedal[{p1,p2},sinhspiral[n,a]][t],
 pedal[{p1,p2},sinoval[5,a]][t],
 pedal[{p1,p2},spring[a,b,v]][t],
 pedal[{p1,p2},strophoid[a]][t],
 pedal[{p1,p2},talbot[a,b,f]][t],
 pedal[{p1,p2},tanhspiral[a]][t],
 pedal[{p1,p2},teardrop[a,b,c,d,n]][t],
 pedal[{p1,p2},tractrix[a]][t],
 pedal[{p1,p2},tractrixminus[a]][s],
 pedal[{p1,p2},tractrixplus[a]][s],
 pedal[{p1,p2},tractrixunitspeed[a]][t],
 pedal[{p1,p2},triangle][t],
 pedal[{p1,p2},trisectrix[a]][t],
 pedal[{p1,p2},tschirnhausen[n,a]][t],
 pedal[{p1,p2},zcprofile[pm,a,c]][t]
}

PEDSURFLIST:=
{pedsurf[{p1,p2,p3},astell[a,b,c]][u,v],
   pedsurf[{p1,p2,p3},bohdom[a,b,c]][u,v],
   pedsurf[{p1,p2,p3},bourpolar[n][t]][u,v],
   pedsurf[{p1,p2,p3},bourpolar[m,n][t]][u,v],
   pedsurf[{p1,p2,p3},boy[a,b,c]][u,v],
   pedsurf[{p1,p2,p3},catalan[a]][u,v],
   pedsurf[{p1,p2,p3},catalandef[a][t]][u,v],
   pedsurf[{p1,p2,p3},catenoid[c]][u,v],
   pedsurf[{p1,p2,p3},circularcone[a,b]][u,v],
   pedsurf[{p1,p2,p3},circularcylinder[a]][u,v],
   pedsurf[{p1,p2,p3},clothoidmin[a][t]][u,v],
   pedsurf[{p1,p2,p3},cnccosurfrev[a,b]][u,v],
   pedsurf[{p1,p2,p3},cnchysurfrev[a,b]][u,v],
   pedsurf[{p1,p2,p3},cpcsurfrev[a,b]][u,v],
   pedsurf[{p1,p2,p3},crosscap[a]][u,v],
   pedsurf[{p1,p2,p3},dini[a,b]][u,v],
   pedsurf[{p1,p2,p3},dinitcheb[a,b]][u,v],
   pedsurf[{p1,p2,p3},ducyc[{q1,q2,q3},rho,a,b]][u,v],
   pedsurf[{p1,p2,p3},earth][u,v],
   pedsurf[{p1,p2,p3},eighteight][u,v],
   pedsurf[{p1,p2,p3},eightsurface][u,v],
   pedsurf[{p1,p2,p3},ellipsemin[a,b][t]][u,v],
   pedsurf[{p1,p2,p3},ellipsoid[a,b,c]][u,v],
   pedsurf[{p1,p2,p3},ellipsoid[a,c]][u,v],
   pedsurf[{p1,p2,p3},ellipticalhyperboloidminus[a,b,c]][u,v],
   pedsurf[{p1,p2,p3},ellipticalhyperboloidplus[a,b,c]][u,v],
   pedsurf[{p1,p2,p3},ellipticcoor[d,e,f][a,b,c][w]][u,v],
   pedsurf[{p1,p2,p3},ellipticparaboloid[a,b]][u,v],
   pedsurf[{p1,p2,p3},enneper][u,v],
   pedsurf[{p1,p2,p3},enneperpolar[n][t]][u,v],
   pedsurf[{p1,p2,p3},ennepercatenoidpolar[n][t]][u,v],
   pedsurf[{p1,p2,p3},funnel[a,b,c]][u,v],
   pedsurf[{p1,p2,p3},genhypparab[a,b]][u,v],
   pedsurf[{p1,p2,p3},handkerchief[a]][u,v],
   pedsurf[{p1,p2,p3},helicoid[a,b,c]][u,v],
   pedsurf[{p1,p2,p3},helicoid[a,c]][u,v],
   pedsurf[{p1,p2,p3},helicoidprin[b]][u,v],
   pedsurf[{p1,p2,p3},heltocat[t]][u,v],
   pedsurf[{p1,p2,p3},henneberg][u,v],
   pedsurf[{p1,p2,p3},hyperbolicparaboloid][u,v],
   pedsurf[{p1,p2,p3},hyperboloid[a,b,c]][u,v],
   pedsurf[{p1,p2,p3},hyperboloid[a,c]][u,v],
   pedsurf[{p1,p2,p3},hy2sheet[a,b,c]][u,v],
   pedsurf[{p1,p2,p3},hy2sheet[a,c]][u,v],
   pedsurf[{p1,p2,p3},kidney[a]][u,v],
   pedsurf[{p1,p2,p3},kleinbottle[a]][u,v],
   pedsurf[{p1,p2,p3},kuen][u,v],
   pedsurf[{p1,p2,p3},kuentcheb[a]][u,v],
   pedsurf[{p1,p2,p3},lemniscatemin[a][t]][u,v],
   pedsurf[{p1,p2,p3},menn[a]][u,v],
   pedsurf[{p1,p2,p3},mercatorellipsoid[a,b,c]][u,v],
   pedsurf[{p1,p2,p3},moebcirc[a]][u,v],
   pedsurf[{p1,p2,p3},moebiusstrip[a]][u,v],
   pedsurf[{p1,p2,p3},monkey[n]][u,v],
   pedsurf[{p1,p2,p3},monkeysaddle][u,v],
   pedsurf[{p1,p2,p3},monkeysaddlepolar[n]][r,theta],
   pedsurf[{p1,p2,p3},paraboliccoor[d,e,f][a,b,c][w]][u,v],
   pedsurf[{p1,p2,p3},paraboloid[a]][u,v],
   pedsurf[{p1,p2,p3},paraboloid[a,b]][u,v],
   pedsurf[{p1,p2,p3},paraboloid[a,b,c]][u,v],
   pedsurf[{p1,p2,p3},perturbedms[a]][u,v],
   pedsurf[{p1,p2,p3},plane[a1,a2,b1,b2,c1,c2]][u,v],
   pedsurf[{p1,p2,p3},plucker][u,v],
   pedsurf[{p1,p2,p3},pluckerpolar[n]][u,v],
   pedsurf[{p1,p2,p3},pluckerpolar[m,n]][u,v],
   pedsurf[{p1,p2,p3},pseudocrosscap][u,v],
   pedsurf[{p1,p2,p3},pseudosphere[a]][u,v],
   pedsurf[{p1,p2,p3},pseudospheretcheb[a]][u,v],
   pedsurf[{p1,p2,p3},rconoid][u,v],
   pedsurf[{p1,p2,p3},richmond][u,v],
   pedsurf[{p1,p2,p3},richmondpolar[n][t]][u,v],
   pedsurf[{p1,p2,p3},roman[a]][u,v],
   pedsurf[{p1,p2,p3},rosemin[n,a][t]][u,v],
   pedsurf[{p1,p2,p3},scherk[a]][u,v],
   pedsurf[{p1,p2,p3},scherk[a,theta]][u,v],
   pedsurf[{p1,p2,p3},scherk5[a,b,c]][u,v],
   pedsurf[{p1,p2,p3},shoe][u,v],
   pedsurf[{p1,p2,p3},sievert[a]][u,v],
   pedsurf[{p1,p2,p3},sinsurface][u,v],
   pedsurf[{p1,p2,p3},snail][u,v],
   pedsurf[{p1,p2,p3},sphere[a]][u,v],
   pedsurf[{p1,p2,p3},stereographicellipsoid[a,b,c]][u,v],
   pedsurf[{p1,p2,p3},swallowtail][u,v],
   pedsurf[{p1,p2,p3},tetrahedral[m,n][A,B,C][a,b,c]][u,v],
   pedsurf[{p1,p2,p3},thomsen[a,b]][u,v],
   pedsurf[{p1,p2,p3},torus[a,b]][u,v],
   pedsurf[{p1,p2,p3},torus[a,b,c]][u,v],
   pedsurf[{p1,p2,p3},twiflat[pm,a,c][sl]][u,v],
   pedsurf[{p1,p2,p3},twisphere[a,b]][u,v],
   pedsurf[{p1,p2,p3},wallis[a,b,c]][u,v],
   pedsurf[{p1,p2,p3},whitneyumbrella][u,v],
   pedsurf[{p1,p2,p3},wrinkles[a]][u,v]
}

KAPPALIST:=
{
kappa[ast3d[n,a,b]][t],
kappa[baseballseam[a,c]][t],
kappa[besselcurve[a,b,c]][t],
kappa[bicylinder[a,b,pm]][t],
kappa[biquadratic[a,k]][t],
kappa[clelia[a][m,n]][t],
kappa[conicalhelix[a,b,c,d]][t],
kappa[cubicalellipse[a,b,c,d,e,f,pm]][t],
kappa[eightknot][t],
kappa[epitrochoid3d[a,b,h,omega]][t],
kappa[genhelix[a,b][f]][t],
kappa[helix[a,b]][t],
kappa[helix[a,b,c]][t],
kappa[helixunitspeed[a,b]][s],
kappa[horopter[a,b]][t],
kappa[line3d[a1,b1,c1,a2,b2,c2]][t],
kappa[lissajous3d[n,d,a,b,c]][t],
kappa[oneparametersubgroup[mat,vec]][t],
kappa[pseudospheregeodesic[a,c,u0,pm]][t],
kappa[pseudosphericalloxodrome[a,b]][t],
kappa[seiffertspiral[a,k]][t],
kappa[sphericalcardioid[a]][t],
kappa[sphericalellipse[a,b,c,pm]][t],
kappa[sphericalhelix[a,b]][t],
kappa[sphericalloxodrome[a,b,c]][t],
kappa[sphericalnephroid[a]][t],
kappa[sphericalspiral[a][m,n]][t],
kappa[torusknot[a,b,c][p,q]][t],
kappa[twicubic][t],
kappa[veryflat[1]][t],
kappa[veryflat[2]][t],
kappa[viviani[a]][t],
kappa[wigglyellipse[n,a,b,c]][t]
}

TAULIST:=
{
tau[ast3d[n,a,b]][t],
tau[baseballseam[a,c]][t],
tau[besselcurve[a,b,c]][t],
tau[bicylinder[a,b,pm]][t],
tau[biquadratic[a,k]][t],
tau[clelia[a][m,n]][t],
tau[conicalhelix[a,b,c,d]][t],
tau[cubicalellipse[a,b,c,d,e,f,pm]][t],
tau[eightknot][t],
tau[epitrochoid3d[a,b,h,omega]][t],
tau[genhelix[a,b][f]][t],
tau[helix[a,b]][t],
tau[helix[a,b,c]][t],
tau[helixunitspeed[a,b]][s],
tau[horopter[a,b]][t],
tau[line3d[a1,b1,c1,a2,b2,c2]][t],
tau[lissajous3d[n,d,a,b,c]][t],
tau[oneparametersubgroup[mat,vec]][t],
tau[pseudospheregeodesic[a,c,u0,pm]][t],
tau[pseudosphericalloxodrome[a,b]][t],
tau[seiffertspiral[a,k]][t],
tau[sphericalcardioid[a]][t],
tau[sphericalellipse[a,b,c,pm]][t],
tau[sphericalhelix[a,b]][t],
tau[sphericalloxodrome[a,b,c]][t],
tau[sphericalnephroid[a]][t],
tau[sphericalspiral[a][m,n]][t],
tau[torusknot[a,b,c][p,q]][t],
tau[twicubic][t],
tau[veryflat[1]][t],
tau[veryflat[2]][t],
tau[viviani[a]][t],
tau[wigglyellipse[n,a,b,c]][t]
}

TANDEVLIST:=
{
tandev[ast3d[n,a,b]][u,v],
tandev[baseballseam[a,c]][u,v],
tandev[besselcurve[a,b,c]][u,v],
tandev[bicylinder[a,b,pm]][u,v],
tandev[biquadratic[a,k]][u,v],
tandev[clelia[a][m,n]][u,v],
tandev[conicalhelix[a,b,c,d]][u,v],
tandev[cubicalellipse[a,b,c,d,e,f,pm]][u,v],
tandev[eightknot][u,v],
tandev[epitrochoid3d[a,b,h,omega]][u,v],
tandev[genhelix[a,b][f]][u,v],
tandev[helix[a,b]][u,v],
tandev[helix[a,b,c]][u,v],
tandev[helixunitspeed[a,b]][s],
tandev[horopter[a,b]][u,v],
tandev[line3d[a1,b1,c1,a2,b2,c2]][u,v],
tandev[lissajous3d[n,d,a,b,c]][u,v],
tandev[oneparametersubgroup[mat,vec]][u,v],
tandev[pseudospheregeodesic[a,c,u0,pm]][u,v],
tandev[pseudosphericalloxodrome[a,b]][u,v],
tandev[seiffertspiral[a,k]][u,v],
tandev[sphericalcardioid[a]][u,v],
tandev[sphericalellipse[a,b,c,pm]][u,v],
tandev[sphericalhelix[a,b]][u,v],
tandev[sphericalloxodrome[a,b,c]][u,v],
tandev[sphericalnephroid[a]][u,v],
tandev[sphericalspiral[a][m,n]][u,v],
tandev[torusknot[a,b,c][p,q]][u,v],
tandev[twicubic][u,v],
tandev[veryflat[1]][u,v],
tandev[veryflat[2]][u,v],
tandev[viviani[a]][u,v],
tandev[wigglyellipse[n,a,b,c]][u,v]
}

ds2LIST:=
{
 ds2[agnesirev[a]][u,v][du,dv],
 ds2[astell[a,b,c]][u,v][du,dv],
 ds2[bohdom[a,b,c]][u,v][du,dv],
 ds2[bour][u,v][du,dv],
 ds2[bourpolar[n][t]][r,theta][dr,dtheta],
 ds2[bourpolar[m,n][t]][r,theta][dr,dtheta],
 ds2[boy[a,b,c]][u,v][du,dv],
 ds2[catalan[a]][u,v][du,dv],
 ds2[catalandef[a][t]][u,v][du,dv],
 ds2[catenoid[c]][u,v][du,dv],
 ds2[catenoid[a,b,c]][u,v][du,dv],
 ds2[catenoidasym[a]][p,q][dp,dq],
 ds2[catenoidiso[a]][u,v][du,dv],
 ds2[circleinvolutemin[1,a][t]][u,v][du,dv],
 ds2[circularcone[a,b]][u,v][du,dv],
 ds2[circularcylinder[a]][u,v][du,dv],
 ds2[clothoidmin[a][t]][u,v][du,dv],
 ds2[cnccosurfrev[a,b]][u,v][du,dv],
 ds2[cnchysurfrev[a,b]][u,v][du,dv],
 ds2[cncsurfrev[a,b]][u,v][du,dv],
 ds2[cnctcheb[a,b]][u,v][du,dv],
 ds2[cossurface[a]][u,v][du,dv],
 ds2[costa][u,v][du,dv],
 ds2[cpcsurfrev[a,b]][u,v][du,dv],
 ds2[crosscap[a]][u,v][du,dv],
 ds2[deltoidinvolutemin[a][t]][u,v][du,dv],
 ds2[deltoidmin[a][t]][u,v][du,dv],
 ds2[dini[a,b]][u,v][du,dv],
 ds2[dinitcheb[a,b]][u,v][du,dv],
 ds2[dinitcheb[a,b,c]][u,v][du,dv],
 ds2[earth][u,v][du,dv],
 ds2[eighteight][u,v][du,dv],
 ds2[eightsurface][u,v][du,dv],
 ds2[ellhypcyclide[a,c,k]][u,v][du,dv],
 ds2[ellipsemin[a,b][t]][u,v][du,dv],
 ds2[ellipsoid[a,b,c]][u,v][du,dv],
 ds2[ellipsoid[a,c]][u,v][du,dv],
 ds2[ellipticalhyperboloidminus[a,b,c]][u,v][du,dv],
 ds2[ellipticalhyperboloidplus[a,b,c]][u,v][du,dv],
 ds2[ellipticcoor[d,e,f][a,b,c][w]][u,v][du,dv],
 ds2[ellipticparaboloid[a,b]][u,v][du,dv],
 ds2[enneper][u,v][du,dv],
 ds2[ennepercatenoidpolar[n][t]][r,theta][dr,dtheta],
 ds2[enneperpolar[n][t]][r,theta][dr,dtheta],
 ds2[exptwist[a,c]][u,v][du,dv],
 ds2[exptwistasym[a,c]][p,q][dp,dq],
 ds2[flattorus[a,b]][u,v][du,dv],
 ds2[flattorus[a,b,c,d]][u,v][du,dv],
 ds2[funnel[a,b,c]][u,v][du,dv],
 ds2[funnelasym[c]][p,q][dp,dq],
 ds2[gencube[n,a,b,c]][u,v][du,dv],
 ds2[genhypparab[a,b]][u,v][du,dv],
 ds2[genoctahedron[n,a,b,c]][u,v][du,dv],
 ds2[handkerchief[a]][u,v][du,dv],
 ds2[heart[a]][u,v][du,dv],
 ds2[helicoid[a,b,c]][u,v][du,dv],
 ds2[helicoid[a,c]][u,v][du,dv],
 ds2[helicoidprin[b]][p,q][dp,dq],
 ds2[heltocat[t]][u,v][du,dv],
 ds2[henneberg][u,v][du,dv],
 ds2[hyperbolicparaboloid][u,v][du,dv],
 ds2[hyperbolicparaboloid[a]][u,v][du,dv],
 ds2[hyperboloid[a,b,c]][u,v][du,dv],
 ds2[hyperboloid[a,c]][u,v][du,dv],
 ds2[hypocycloidinvolutemin[a,b][t]][u,v][du,dv],
 ds2[hy2sheet[a,b,c]][u,v][du,dv],
 ds2[hy2sheet[a,c]][u,v][du,dv],
 ds2[invertedcircularcone[{p1,p2,p3},rho,a,b]][u,v][du,dv],
 ds2[invertedcircularcone[rho,a,b]][u,v][du,dv],
 ds2[invertedcircularcylinder[{p1,p2,p3},rho,a]][u,v][du,dv],
 ds2[invertedcircularcylinder[rho,a]][u,v][du,dv],
 ds2[invertedtorus[{p1,p2,p3},rho,a,b]][u,v][du,dv],
 ds2[invertedtorus[rho,a,b]][u,v][du,dv],
 ds2[kidney[a]][u,v][du,dv],
 ds2[kleinbottle[a]][u,v][du,dv],
 ds2[kleinbottlebis[e,f]][u,v][du,dv],
 ds2[klein4[a,b]][u,v][du,dv],
 ds2[kuen[a]][u,v][du,dv],
 ds2[kuentcheb[a]][u,v][du,dv],
 ds2[kuentcheb[a,b]][u,v][du,dv],
 ds2[kuentcheb[a,b,c]][u,v][du,dv],
 ds2[lemniscatemin[a][t]][u,v][du,dv],
 ds2[menn[a]][u,v][du,dv],
 ds2[mercatorellipsoid[a,b,c]][u,v][du,dv],
 ds2[moebcirc[a]][u,v][du,dv],
 ds2[moebiusstrip[a]][u,v][du,dv],
 ds2[monkeysaddle][u,v][du,dv],
 ds2[monkeysaddle[n]][r,theta][dr,dtheta],
 ds2[monkeysaddlepolar[n]][r,theta][dr,dtheta],
 ds2[parabolamin[a][t]][u,v][du,dv],
 ds2[paraboliccoor[d,e,f][a,b,c][w]][u,v][du,dv],
 ds2[paraboliccyclide[a,k]][u,v][du,dv],
 ds2[paraboloid[a]][u,v][du,dv],
 ds2[paraboloid[a,b]][u,v][du,dv],
 ds2[paraboloid[a,b,c]][u,v][du,dv],
 ds2[paraboloidpolar[n,a,b]][r,theta][dr,dtheta],
 ds2[pear[a,b]][u,v][du,dv],
 ds2[perturbedms[a]][u,v][du,dv],
 ds2[pillow[a]][u,v][du,dv],
 ds2[plane[a1,a2,b1,b2,c1,c2]][u,v][du,dv],
 ds2[planepolar[a]][r,theta][dr,dtheta],
 ds2[plucker][u,v][du,dv],
 ds2[plucker[n]][u,v][du,dv],
 ds2[plucker[m,n]][u,v][du,dv],
 ds2[pluckerpolar[n]][r,theta][dr,dtheta],
 ds2[pluckerpolar[m,n,a]][r,theta][dr,dtheta],
 ds2[pseudocrosscap][u,v][du,dv],
 ds2[pseudosphere[a]][u,v][du,dv],
 ds2[pseudosphere[a,b]][u,v][du,dv],
 ds2[pseudosphere[a,b,c]][u,v][du,dv],
 ds2[pseudospherebis[a]][u,v][du,dv],
 ds2[pseudospheretcheb[a]][u,v][du,dv],
 ds2[pseudospheretcheb[a,b]][u,v][du,dv],
 ds2[pseudospheretcheb[a,b,c]][u,v][du,dv],
 ds2[pseudospheretcheb[a,b,c,d]][u,v][du,dv],
 ds2[rconoid][u,v][du,dv],
 ds2[richmond][u,v][du,dv],
 ds2[richmondpolar[n][t]][r,theta][dr,dtheta],
 ds2[roman[a]][u,v][du,dv],
 ds2[roman[n,a]][u,v][du,dv]
 ds2[rosemin[n,a][t]][u,v][du,dv],
 ds2[scherk[a]][u,v][du,dv],
 ds2[scherk[a,theta]][u,v][du,dv],
 ds2[scherk5[a,b,c]][u,v][du,dv],
 ds2[shoe[a,b]][u,v][du,dv],
 ds2[shoeasym[a,b]][p,q][dp,dq],
 ds2[sievert[a]][u,v][du,dv],
 ds2[sinovaloid[5,a]][u,v][du,dv],
 ds2[sinsurface[a]][u,v][du,dv],
 ds2[snail][u,v][du,dv],
 ds2[sphere[a]][u,v][du,dv],
 ds2[stereographicellipsoid[a,b,c]][u,v][du,dv],
 ds2[stereographicsphere[a]][u,v][du,dv],
 ds2[stereographicspherepolar[a]][r,theta][dr,dtheta],
 ds2[swallowtail][u,v][du,dv],
 ds2[tetrahedral[m,n][A,B,C][a,b,c]][u,v][du,dv],
 ds2[thomsen[a,b]][u,v][du,dv],
 ds2[torus[a,b]][u,v][du,dv],
 ds2[torus[a,b,c]][u,v][du,dv],
 ds2[torus[a,b,c,d]][u,v][du,dv],
 ds2[torus[a,b,c,d,e]][u,v][du,dv],
 ds2[twiflat[pm,a,c][sl]][u,v][du,dv],
 ds2[twisphere[a,b]][u,v][du,dv],
 ds2[veronese[a]][u,v][du,dv],
 ds2[wallis[a,b,c]][u,v][du,dv],
 ds2[whitneyumbrella][u,v][du,dv],
 ds2[wrinkles[a]][u,v]
}

TUBECURVELIST:=
{
 tubecurve[bicylinder[a,b,pm]][r][t,theta],
 tubecurve[clelia[a][m,n]][r][t,theta],
 tubecurve[conicalhelix[a,b,c,d]][r][t,theta],
 tubecurve[cubicalellipse[a,b,c,d,e,f,pm]][r][t,theta],
 tubecurve[eightknot][r][t,theta],
 tubecurve[epitrochoid3d[a,b,h,omega]][r][t,theta],
 tubecurve[helix[a,b]][r][t,theta],
 tubecurve[helix[a,b,c]][r][t,theta],
 tubecurve[horopter[a,b]][r][t,theta],
 tubecurve[lissajous3d[n,d,a,b,c]][r][t,theta],
 tubecurve[sphericalcardioid[a]][r][t,theta],
 tubecurve[sphericalhelix[a,b]][r][t,theta],
 tubecurve[sphericalnephroid[a]][r][t,theta],
 tubecurve[sphericalspiral[a][m,n]][r][t,theta],
 tubecurve[torusknot[a,b,c][p,q]][r][t,theta],
 tubecurve[twicubic][r][t,theta],
tubecurve[viviani[a]][r][t,theta]
}

